﻿#region Header
//
//   Project:           WriteableBitmapEx - Silverlight WriteableBitmap extensions
//   Description:       Blit Sample for the WriteableBitmap extension methods.
//
//   Changed by:        $Author: unknown $
//   Changed on:        $Date: 2012-06-13 01:09:50 -0700 (周三, 13 六月 2012) $
//   Changed in:        $Revision: 91730 $
//   Project:           $URL: https://writeablebitmapex.svn.codeplex.com/svn/trunk/Source/WriteableBitmapExBlitSample/Particle.cs $
//   Id:                $Id: Particle.cs 91730 2012-06-13 08:09:50Z unknown $
//
//
//   Copyright © 2009-2010 Bill Reiss, Rene Schulte and WriteableBitmapEx Contributors
//
//   This Software is weak copyleft open source. Please read the License.txt for details.
//
#endregion

#if NETFX_CORE
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.Foundation;
using System.Collections.Generic;
using Windows.UI;
#else
using System.Collections.Generic;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;
#endif

namespace WriteableBitmapExBlitSample
{
   public class Particle
   {
      #region Fields

      public Point Position;
      public Point Velocity;
      public Color Color;
      public double Lifespan;
      public double Elapsed;

      #endregion

      #region Methods

      public void Initiailize()
      {
         Elapsed = 0;
      }

      public void Update(double elapsedSeconds)
      {
         Elapsed += elapsedSeconds;
         if (Elapsed > Lifespan)
         {
            Color.A = 0;
            return;
         }
         Color.A = (byte)(255 - ((255 * Elapsed)) / Lifespan);
         Position.X += Velocity.X * elapsedSeconds;
         Position.Y += Velocity.Y * elapsedSeconds;
      }

      #endregion
   }
}
